"""eulerworkbench.plugins.fetch
Fetcher plugin for fetching a problem from Project Euler page.

Copyright (C) 2014  Stijn Wouters  <w.stijn@gmail.com>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Last modified: 10 August 2014.
By: Stijn Wouters.
"""
import click
import eulerworkbench.eulerworkbench as ewb


pass_workbench = click.make_pass_decorator(ewb.EulerWorkbench, ensure=True)


@click.command('fetch')
@click.argument('problem', type=click.IntRange(1, None))
@click.option('--timeout', type=click.IntRange(1, None), default=10,
              help='Connection timeout (in seconds).')
@pass_workbench
def main(workbench, problem, timeout):
    """Fetch problem from Project Euler.
    """
    the_problem = workbench.fetch(problem, timeout=timeout)

    if '' == the_problem:
        raise click.BadParameter('Could\'t find problem {:d}'.format(problem))
    else:
        click.echo(the_problem)
